ECMAScript 6 学习笔记(十一):Promise 对象

简介

Promise 是异步编程的一种解决方案,简单来说就是一个异步事件的容器,可以通过它获取异步操作的结果。有了 Promise 对象,就可以以同步操作的流程处理异步操作,避免了“回调地狱”,因此使得控制异步操作更加容易。

Promise对象有以下两个特点:

  • 对象状态不受外界影响。Promise对象有三种状态:pending(进行中)、fulfilled(已成功)和rejected(已失败)。状态由异步操作的结果决定,其他任何操作都无法改变;
  • 对象状态一旦确定就不会再变。传统的事件监听是,每次触发都会得到不一样的结果,而Promise对象一旦变化,状态就确定不会再变了,在对Promise对象添加回调函数也会立即得到相同的结果。

基本用法

Promise对象是一个构造函数,接受一个函数作为参数,该函数的两个参数分别是resolvereject,这是两个由 ES 引擎提供的函数。

const promise = new Promise(function(resolve, reject) {
  // ... some code

  if (/* 异步操作成功 */){
    resolve(value);
  } else {
    reject(error);
  }
});

resolve函数的作用是将Promise对象的状态从“未完成(pending)”变成“成功(resolved)”,在异步操作成功时调用,并将异步操作的结果作为参数传递出去;而reject函数的作用则是将Promise对象的状态从“未完成(pending)”变成“失败(rejected)”,在异步操作失败时调用,并将错误以参数的形式传递出去。

Promise实例生成后,可以用then方法分别指定resolvedrejected状态的回调函数,其中rejected状态的回调函数为可选项。这两个函数都接受Promise对象传出的值作为参数。

promise.then(function(value) {
  // success
}, function(error) {
  // failure
});

Promise实例的执行顺序:

let promise = new Promise(function(resolve, reject) {
  console.log('Promise');
  resolve();
});

promise.then(function() {
  console.log('resolved.');
});

console.log('Hi!');

// Promise
// Hi!
// resolved

Promise实例可以返回另一个Promise对象:

const p1 = new Promise(function (resolve, reject) {
  setTimeout(() => reject(new Error('fail')), 3000)
})

const p2 = new Promise(function (resolve, reject) {
  setTimeout(() => resolve(p1), 1000)
})

p2
  .then(result => console.log(result))
  .catch(error => console.log(error))
// Error: fail

上面给出的例子中,p2 必须等到 p1 的状态完成后才会执行,相当于 p2 本身的状态无效了,因此 3s 后才会触发catch方法。

Promise 的方法

Promise.prototype.then()

前面已经介绍了then()的用法,但是有一点没有说到,then方法返回的是一个全新的Promise实例,因此可以采用链式写法。使用链式写法时,前一个then的回调函数的返回结果会作为参数传给下一个回调函数。

promise.then(function(x) {
    return y;
}).then(function(y)) {
   // ...
});

Promise.prototype.catch()

这个方法相当于.then(null/undefined, rejection)的别名,用于指定发生错误时的回调函数。一般来说,不要在then方法里面定义 Reject 状态的回调函数(即then的第二个参数),总是使用catch方法。Promise 对象的错误具有“冒泡”性质,会一直向后传递,直到被捕获为止。也就是说,错误总是会被下一个catch语句捕获。

// 写法一
const promise = new Promise(function(resolve, reject) {
  try {
    throw new Error('test');
  } catch(e) {
    reject(e);
  }
});
promise.catch(function(error) {
  console.log(error);
});

// 写法二
const promise = new Promise(function(resolve, reject) {
  reject(new Error('test'));
});
promise.catch(function(error) {
  console.log(error);
});

需要注意的是,Promise对象抛出的错误不会传递到外层代码,即不会有任何反应。也就是说就算Promise对象执行时发生错误,也不会影响外部代码的执行。

const promise = new Promise(function (resolve, reject) {
  resolve('ok');
  setTimeout(function () { throw new Error('test') }, 0)
});
promise.then(function (value) { console.log(value) });
// ok
// Uncaught Error: test

按照前面的说法,上述代码应该不会输出错误信息才对,因为没有catch处理错误,为什么这里会正常显示错误信息呢?原因是,在上面的代码中,resolvesetTimeout总共两个事件被添加到消息队列中,在第一轮事件循环中Promise的运行已经结束了,setTimeout抛出的错误信息是在第二轮事件循环时,此时已经在Promise对象外了。

Promise.prototype.finally()

finally方法用于指定不管Promise对象最后状态如何,都会执行的操作。

promise
.then(result => {···})
.catch(error => {···})
.finally(() => {···});

// finally 等同于
promise
.then(
  result => {
    // 语句
    return result;
  },
  error => {
    // 语句
    throw error;
  }
);

Promise.resolve() 和 Promise.reject()

有时需要将现有对象转成 Promise 对象,这两个方法就起这样的作用。

Promise.resolve()

该方法等价于:

Promise.resolve('foo')
// 等价于
new Promise(resolve => resolve('foo'))

传入该方法的参数根据类型可分为四种情况:

  1. 参数是一个 Promise 实例

不做任何修改,直接返回这个实例。

  1. 参数是一个包含then方法的对象

转为Promise对象,然后立即执行该对象中的then方法。

  1. 参数是不具有then方法的对象或者不是对象

返回一个新的状态为resolved的对象。

  1. 不带任何参数

返回一个新的状态为resolved的对象。

Promise.reject()

Promise.resolve()不同,Promise.reject()方法的参数会原封不动地变成后续方法的参数。

const thenable = {
  then(resolve, reject) {
    reject('出错了');
  }
};

Promise.reject(thenable)
.catch(e => {
  console.log(e === thenable) // true
})

Promise.all() 和 Promise.race()

这两个方法的作用是将多个 Promise 实例包装成一个新的 Promise 实例,它们接受一个由 Promise 实例组成的数组作为参数,如果数组中有不是 Promise 实例的元素,则会先调用Promise.resolve()方法进行转换。

  1. Promise.all()
const p = Promise.all([p1, p2, p3]);
  • p1p2p3的状态都变成fulfilled时,p的状态才会变成fulfilled,此时p1p2p3的返回值组成一个数组传递给p的回调函数。
  • 只要p1p2p3中有一个被rejectedp的状态就变成rejected,此时第一个被reject的实例的返回值,会传递给p的回调函数。

注意,如果作为参数的 Promise 实例,自己定义了catch方法,那么它一旦被rejected,并不会触发Promise.all()catch方法。

  1. Promise.race()

Promise.all()不同,只要p1p2p3中有一个实例率先改变状态,p的状态就跟着改变,那个率先改变的 Promise 实例的返回值,就传递给p的回调函数。

Promise.try()

实际开发中,经常遇到一种情况:不知道或者不想区分,函数f是同步函数还是异步操作,但是想用 Promise 来处理它。因为这样就可以不管f是否包含异步操作,都用then方法指定下一步流程,用catch方法处理f抛出的错误。一般就会采用下面的写法。

Promise.resolve().then(f)

但是这样写的问题在于,f同步函数会被转成异步执行的函数,为了让同步函数同步执行,异步函数异步执行,并且让它们具有统一的 API,目前有两个写法,一种是用async函数来写,这个函数以后会介绍到,另一种就是使用new Promise()

const f = () => console.log('now');
(() => new Promise(
  resolve => resolve(f());
))();
console.log('next');
// now
// next

上面代码也是使用立即执行的匿名函数,执行new Promise()。这种情况下,同步函数也是同步执行的。鉴于这是一个很常见的需求,所以现在有一个提案,提供Promise.try方法替代上面的写法。

const f = () => console.log('now');
Promise.try(f);
console.log('next');
// now
// next

Promise 的应用

  1. 利用Promise实现异步加载图片:
const preloadImage = function (path) {
  return new Promise(function (resolve, reject) {
    const image = new Image();
    image.onload  = resolve;
    image.onerror = reject;
    image.src = path;
  });
};
  1. 利用Promise实现 Ajax 操作:
const getJSON = function(url) {
  const promise = new Promise(function(resolve, reject){
    const handler = function() {
      if (this.readyState !== 4) {
        return;
      }
      if (this.status === 200) {
        resolve(this.response);
      } else {
        reject(new Error(this.statusText));
      }
    };
    const client = new XMLHttpRequest();
    client.open("GET", url);
    client.onreadystatechange = handler;
    client.responseType = "json";
    client.setRequestHeader("Accept", "application/json");
    client.send();
  });
  return promise;
};

getJSON("/posts.json").then(function(json) {
  console.log('Contents: ' + json);
}, function(error) {
  console.error('出错了', error);
});
  1. Generator 函数和 Promise 的结合
function getFoo () {
  return new Promise(function (resolve, reject){
    resolve('foo');
  });
}

const g = function* () {
  try {
    const foo = yield getFoo();
    console.log(foo);
  } catch (e) {
    console.log(e);
  }
};

function run (generator) {
  const it = generator();

  function go(result) {
    if (result.done) return result.value;

    return result.value.then(function (value) {
      return go(it.next(value));
    }, function (error) {
      return go(it.throw(error));
    });
  }

  go(it.next());
}

run(g);
点赞

发表评论

电子邮件地址不会被公开。